
!	Include file for the AskIt proc

.IF DECPASS

	String AskIt(Prompt$,RespLen,Timeout)
	
.ELSE

String AskIt(Prompt$,RespLen,Timeout)

	Length	254	&	Local Prompt$, Response$
	Length	5.0	&	Local RespLen, Timeout		! Timeout value is in seconds
	Length	10.0	&	Local EditID
	
	Include "CometWin.Inc"
	
	SET IDD.DIALOG1 =             101
	SET IDC.Password =            1001
	SET IDC.Prompt =              1002
	SET IDC.EDIT2 =               1003
	
	EditID = IDC.EDIT2
	If lcase(prompt$) contains 'password' EditID = IDC.Password

	EventSub EventHandler CW.Event$ CW.Source$
	if Timeout > 0 SetTimer "AskIt" Timeout*1000

	cosDllNames$ = "JimsDLL.dll"
	cosDllDir$ = Sub(PStat(PARTITION$), 41, 3)	! Same dir as this program
	cosDlgId = IDD.DIALOG1								! Dialog ID
	Gosub CW.CreateModalDialog							! Execute dialog
	If cosDlgOpen = FALSE ProcReturn "-ERR Dialog execution failed"

	EventWait

ProcExit:
	ProcReturn Response$

EventHandler:
	if sub(CW.Event$,1,7) = ":TIMER\"
		Response$ = "-ERR Timer expired"
		SetTimer "", 0
		Gosub COS.EndDialog
		Go EndEvents
	endif
	
	Gosub CW.ParseEvent
	Select Case cosCtlId
		Case ID.OK
			cosCtlId = EditID
			Gosub COS.GetDlgItemText
			Response$ = cosCtlText$
			Gosub COS.EndDialog

		Case ID.CANCEL
			Response$ = "-ERR User canceled dialog"
			Gosub COS.EndDialog

		Case else						! If cosCtlId is invalid then we probably got a message
			Gosub CW.IsWindowInitializing
			if cosState = TRUE
				Gosub InitDialog
			else
				gosub CW.IsWindowClosing
				if cosState = TRUE
					cosDlgResult = coswParam
					CW.ExitEvents = TRUE
				endif
			endif
	EndSelect

EndEvents:
	If (CW.ExitEvents EQ TRUE)
		EventSub
	Else
		EventSub EventHandler CW.Event$ CW.Source$		! re-Set EventSub address
	EndIf
	Return


InitDialog:
	! Set command filter
	cosCtlText$ = _
		Intel(ID.OK) + Intel(BN.CLICKED) + _
		Intel(ID.CANCEL) + Intel(BN.CLICKED)
	cosCWnd$ = cosDlghDlg$
	Gosub COS.AppendCmdFilter

	Gosub SetupDlg

	! Show this dialog
	cosCWnd$ = cosDlghDlg$
	cosState = SW.NORMAL
	Gosub COS.ShowWindow
	Return

SetupDlg:
	cosCtlText$ = Prompt$
	Gosub COS.SetWindowText
	cosCtlId = IDC.Prompt
	Gosub COS.SetDlgItemText
	
	cosCtlId = EditID
	cosItemSize = abs(RespLen)		! Maximum # chars
	Gosub COS.EditLimitText
	Gosub COS.SetDlgItemFocus
	
	If RespLen < 0
		cosCtlId = IDOK
		cosState = SW.HIDE
		Gosub COS.ShowDlgItem
	
		cosCtlId = IDCANCEL
		cosState = SW.HIDE
		Gosub COS.ShowDlgItem
	Endif

	If EditID = IDC.Password
		cosCtlId = IDC.EDIT2
	Else
		cosCtlId = IDC.Password
	Endif 	
	cosState = SW.HIDE
	Gosub COS.ShowDlgItem
	Return


Include "CometWin.Inc"

	End
.ENDIF
